#ifdef WIN32
#include "details/socket_win.hpp"
#else
#include "details/socket_unix.hpp"
#endif
#include "socket.hpp"
 
namespace fcf {
namespace net {

  socket_t::~socket_t(){
  }

  void socket_t::send_all(const char* a_data, unsigned int a_size){
    int sc = 0;
    while(sc < a_size)
      sc += send(a_data, a_size);
  }

  socket_t* create_socket(const char* a_address, int a_port){
    return new details::socket_t(a_address, a_port);
  }

  socket_t* create_socket_attach(socket_handle_t a_socket_handle, const char* a_address, int a_port){
    return new details::socket_t(a_socket_handle, a_address, a_port); 
  }

} // net namespace
} // fcf namespace
